package gregapi.block;

import static gregapi.data.CS.W;
import gregapi.lang.LanguageHandler;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.item.ItemBlock;
import net.minecraft.util.StatCollector;
import cpw.mods.fml.common.registry.GameRegistry;

public abstract class BlockBase extends Block {
	public final String mNameInternal;
	
	public BlockBase(Class<? extends ItemBlock> aItemClass, String aNameInternal, Material aMaterial) {
		super(aMaterial);
		setBlockName(mNameInternal = aNameInternal);
		GameRegistry.registerBlock(this, aItemClass, getUnlocalizedName());
		LanguageHandler.add(mNameInternal+"."+W+".name", "Any Sub-Block of this one");
	}
	
	@Override public final String getUnlocalizedName() {return mNameInternal;}
	@Override public String getLocalizedName() {return StatCollector.translateToLocal(mNameInternal+ ".name");}
}