package gregapi.block.metatype;

import static gregapi.data.CS.*;
import gregapi.block.BlockBase;
import gregapi.data.LH;
import gregapi.data.OP;
import gregapi.oredict.OreDictMaterial;
import gregapi.recipes.GT_ModHandler;
import gregapi.render.IIconContainer;
import gregapi.util.UT;

import java.util.List;
import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IIcon;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.common.util.ForgeDirection;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

public class GT_Block_MetaType extends BlockBase {
	public final float mHardnessMultiplier, mResistanceMultiplier;
	public final int mHarvestLevel;
	public final byte mSide, mCount;
	public final IIconContainer[] mIcons;
	public final GT_Block_MetaType mBlock;
	public final GT_Block_MetaType[] mSlabs;
	
	public GT_Block_MetaType(Class<? extends ItemBlock> aItemClass, Material aVanillaMaterial, SoundType aVanillaSoundType, String aName, String aDefaultLocalised, OreDictMaterial aMaterial, float aResistanceMultiplier, float aHardnessMultiplier, int aHarvestLevel, int aCount, IIconContainer[] aIcons) {
        super(aItemClass, aName, aVanillaMaterial);
        setStepSound(aVanillaSoundType);
        setHardness(aHardnessMultiplier * 1.5F);
        setResistance(aResistanceMultiplier * 10.0F);
        setCreativeTab(CreativeTabs.tabBlock);
        mBlock = this;
        mIcons = aIcons;
        mCount = (byte)(UT.Code.bind4(aCount-1)+1);
        mSide = SIDE_UNKNOWN;
        mHarvestLevel = aHarvestLevel;
        mHardnessMultiplier = aHardnessMultiplier;
        mResistanceMultiplier = aResistanceMultiplier;
        mSlabs = new GT_Block_MetaType[] {
          makeSlab(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier / 2, aHardnessMultiplier / 2, aHarvestLevel, mCount, aIcons, SIDE_DOWN		, this)
        , makeSlab(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier / 2, aHardnessMultiplier / 2, aHarvestLevel, mCount, aIcons, SIDE_UP		, this)
        , makeSlab(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier / 2, aHardnessMultiplier / 2, aHarvestLevel, mCount, aIcons, SIDE_NORTH	, this)
        , makeSlab(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier / 2, aHardnessMultiplier / 2, aHarvestLevel, mCount, aIcons, SIDE_SOUTH	, this)
        , makeSlab(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier / 2, aHardnessMultiplier / 2, aHarvestLevel, mCount, aIcons, SIDE_WEST		, this)
        , makeSlab(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier / 2, aHardnessMultiplier / 2, aHarvestLevel, mCount, aIcons, SIDE_EAST		, this)
        , null};
        mSlabs[SIDE_INVALID] = mSlabs[SIDE_DOWN];
        UT.Stacks.hide(mSlabs[SIDE_UP]);
        UT.Stacks.hide(mSlabs[SIDE_NORTH]);
        UT.Stacks.hide(mSlabs[SIDE_SOUTH]);
        UT.Stacks.hide(mSlabs[SIDE_WEST]);
        UT.Stacks.hide(mSlabs[SIDE_EAST]);
        for (byte i = 0; i < 16; i++) {
        	GT_ModHandler.addSawingRecipe(16, 16, F, 5, UT.Stacks.make(this, 1, i), UT.Stacks.make(mSlabs[0], 2, i));
        	GT_ModHandler.addCraftingRecipe(UT.Stacks.make(mSlabs[0], 2, i), GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"sX", 'X', UT.Stacks.make(this, 1, i)});
        	GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, i), GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"X", "X", 'X', UT.Stacks.make(mSlabs[0], 1, i)});
        }
	}
	
	protected GT_Block_MetaType makeSlab(Class<? extends ItemBlock> aItemClass, Material aVanillaMaterial, SoundType aVanillaSoundType, String aName, String aDefaultLocalised, OreDictMaterial aMaterial, float aResistanceMultiplier, float aHardnessMultiplier, int aHarvestLevel, int aCount, IIconContainer[] aIcons, byte aSlabType, GT_Block_MetaType aBlock) {
		return new GT_Block_MetaType(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier, aHardnessMultiplier, aHarvestLevel, aCount, aIcons, aSlabType, aBlock);
	}
	
	protected GT_Block_MetaType(Class<? extends ItemBlock> aItemClass, Material aVanillaMaterial, SoundType aVanillaSoundType, String aName, String aDefaultLocalised, OreDictMaterial aMaterial, float aResistanceMultiplier, float aHardnessMultiplier, int aHarvestLevel, int aCount, IIconContainer[] aIcons, byte aSlabType, GT_Block_MetaType aBlock) {
		super(aItemClass, aName+".slab."+aSlabType, aVanillaMaterial);
        setStepSound(aVanillaSoundType);
        setHardness(aHardnessMultiplier * 1.5F);
        setResistance(aResistanceMultiplier * 10.0F);
        mSlabs = null;
        mBlock = aBlock;
        mIcons = aIcons;
        mCount = (byte)(UT.Code.bind4(aCount-1)+1);
        mSide = aSlabType;
        mHarvestLevel = aHarvestLevel;
        mHardnessMultiplier = aHardnessMultiplier;
        mResistanceMultiplier = aResistanceMultiplier;
        setBlockBounds(
        mSide == SIDE_X_POS ? 0.5F : 0.0F,
        mSide == SIDE_Y_POS ? 0.5F : 0.0F,
        mSide == SIDE_Z_POS ? 0.5F : 0.0F,
        mSide == SIDE_X_NEG ? 0.5F : 1.0F,
        mSide == SIDE_Y_NEG ? 0.5F : 1.0F,
        mSide == SIDE_Z_NEG ? 0.5F : 1.0F
        );
	}
	
	@Override
    public boolean onBlockActivated(World aWorld, int aX, int aY, int aZ, EntityPlayer aPlayer, int aSide, float aHitX, float aHitY, float aHitZ) {
		if (mBlock == this || aSide != OPPOSITES[mSide] || (mBlock.getCollisionBoundingBoxFromPool(aWorld, aX, aY, aZ) != null && !aWorld.checkNoEntityCollision(mBlock.getCollisionBoundingBoxFromPool(aWorld, aX, aY, aZ)))) return F;
		ItemStack aStack = aPlayer.getCurrentEquippedItem();
		byte aMetaData = (byte)aWorld.getBlockMetadata(aX, aY, aZ);
		if (UT.Stacks.equal(aStack, UT.Stacks.make(mBlock.mSlabs[0], 1, aMetaData), T)) {
			aWorld.setBlock(aX, aY, aZ, mBlock, aMetaData, 3);
			aWorld.playSoundEffect(aX + 0.5F, aY + 0.5F, aZ + 0.5F, mBlock.stepSound.func_150496_b(), (mBlock.stepSound.getVolume() + 1.0F) / 2.0F, mBlock.stepSound.getPitch() * 0.8F);
			if (!UT.Entities.hasInfiniteItems(aPlayer)) aStack.stackSize--;
	        return T;
		}
        return F;
    }
    
	public float getExplosionResistance(int aMeta) {return Blocks.stone.getExplosionResistance(null) * mResistanceMultiplier;}
	public int getItemStackLimit(ItemStack aStack) {return UT.Code.bindStack(OP.stone.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));}
	
	public void addInformation(ItemStack aStack, EntityPlayer aPlayer, List aList, boolean aF3_H) {
    	aList.add(LH.Chat.CYAN + LH.get(LH.TOOLTIP_SPAWNPROOF));
    	aList.add(LH.Chat.WHITE + LH.get(LH.TOOLTIP_BLASTRESISTANCE) + LH.Chat.ORANGE + (getExplosionResistance(UT.Stacks.meta(aStack))));
    }
    
    @Override
	@SideOnly(Side.CLIENT)
    public boolean shouldSideBeRendered(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {
    	if (aSide == OPPOSITES[mSide]) return T;
    	if (aSide != mSide && SIDES_VALID[mSide]) {
        	Block aBlock = aWorld.getBlock(aX, aY, aZ);
        	if (aBlock instanceof GT_Block_MetaType && ((GT_Block_MetaType)aBlock).mSide == mSide) return aBlock.getRenderBlockPass() != 0;
    	}
        return super.shouldSideBeRendered(aWorld, aX, aY, aZ, aSide);
    }
    
	@Override public String getHarvestTool(int aMeta) {return TOOL_pickaxe;}
    @Override public boolean isToolEffective(String aType, int aMeta) {return getHarvestTool(aMeta).equals(aType);}
	@Override public int getHarvestLevel(int aMeta) {return mHarvestLevel;}
	@Override public float getBlockHardness(World aWorld, int aX, int aY, int aZ) {return Blocks.stone.getBlockHardness(aWorld, aX, aY, aZ) * mHardnessMultiplier;}
    @Override public float getExplosionResistance(Entity aEntity, World aWorld, int aX, int aY, int aZ, double eX, double eY, double eZ) {return getExplosionResistance(aWorld.getBlockMetadata(aX, aY, aZ));}
    @Override public float getExplosionResistance(Entity aEntity) {return getExplosionResistance(0);}
	@Override public boolean canBeReplacedByLeaves(IBlockAccess aWorld, int aX, int aY, int aZ) {return F;}
	@Override public boolean isNormalCube(IBlockAccess aWorld, int aX, int aY, int aZ)  {return mBlock == this;}
	@Override public boolean renderAsNormalBlock() {return mBlock == this;}
	@Override public boolean isOpaqueCube() {return mBlock == this;}
	@Override public boolean canCreatureSpawn(EnumCreatureType type, IBlockAccess aWorld, int aX, int aY, int aZ) {return F;}
    @Override public boolean isSideSolid(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aDirection) {return mBlock == this || mSide == UT.Code.side(aDirection);}
	@Override public int damageDropped(int aMeta) {return aMeta;}
	@Override public int getDamageValue(World aWorld, int aX, int aY, int aZ) {return aWorld.getBlockMetadata(aX, aY, aZ);}
	@Override public int quantityDropped(Random par1Random) {return 1;}
	@Override public Item getItemDropped(int par1, Random par2Random, int par3) {return Item.getItemFromBlock(mBlock == this ? mBlock : mBlock.mSlabs[0]);}
    @Override public void registerBlockIcons(IIconRegister aIconRegister) {/**/}
	@Override public void getSubBlocks(Item aItem, CreativeTabs par2CreativeTabs, List aList) {if (mBlock == this || mBlock.mSlabs[0] == this) for (byte i = 0; i < mCount; i++) aList.add(UT.Stacks.make(aItem, 1, i));}
	@Override public IIcon getIcon(int aSide, int aMeta) {if (aMeta >= 0 && aMeta < mIcons.length) return mIcons[aMeta].getIcon(0); return mIcons[0].getIcon(0);}
    @Override public Item getItem(World aWorld, int aX, int aY, int aZ) {return Item.getItemFromBlock(mBlock == this ? mBlock : mBlock.mSlabs[0]);}
}