package gregapi.compat.industrialcraft;

import static gregapi.data.CS.F;
import static gregapi.data.CS.T;
import gregapi.code.ItemStackContainer;
import gregapi.code.ItemStackSet;
import gregapi.compat.CompatBase;
import gregapi.config.ConfigCategories;
import gregapi.data.CS.BlocksGT;
import gregapi.data.CS.ConfigsGT;
import gregapi.data.IL;
import gregapi.util.OM;
import gregapi.util.UT;
import ic2.api.recipe.RecipeInputItemStack;
import net.minecraft.block.Block;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;

public class CompatIC2 extends CompatBase implements ICompatIC2 {
	public CompatIC2() {
		// Checking if everything is available.
		valuable(Blocks.glowstone, 0, 1);
		valuable(Blocks.soul_sand, 0, 1);
		if (ic2.api.recipe.Recipes.scrapboxDrops == null) {/**/}
		if (ic2.api.recipe.Recipes.recyclerBlacklist == null) {/**/}
		if (ic2.api.recipe.Recipes.recyclerWhitelist == null) {/**/}
	}
	
	@Override
	public void onPostLoad(FMLPostInitializationEvent aEvent) {
    	for (Object tOre : BlocksGT.stoneToSmallOres .values()) valuable((Block)tOre, 2);
    	for (Object tOre : BlocksGT.stoneToNormalOres.values()) valuable((Block)tOre, 2);
    	for (Object tOre : BlocksGT.stoneToBrokenOres.values()) valuable((Block)tOre, 2);
    	
		if (mToBlacklist != null) {
			for (ItemStackContainer tStack : mToBlacklist) ic2.api.recipe.Recipes.recyclerBlacklist.add(new RecipeInputItemStack(tStack.toStack()));
			mToBlacklist.clear();
			mToBlacklist = null;
		}
	}
	
	@Override
	public boolean valuable(Block aBlock, int aMeta, int aValue) {
		if (aValue <= 0) return F;
		ic2.core.IC2.addValuableOre(new RecipeInputItemStack(UT.Stacks.make(aBlock, 1, aMeta)), aValue);
		return T;
	}
	
	@Override
	public boolean valuable(Block aBlock, int aValue) {
		if (aValue <= 0) return F;
		for (byte i = 0; i < 16; i++) valuable(aBlock, i, aValue);
		return T;
	}
	
	@Override
    public ItemStack recycler(ItemStack aInput, int aScrapChance) {
    	if (aInput == null || aScrapChance != 0 || ic2.api.recipe.Recipes.recyclerBlacklist.contains(aInput)) return null;
		return ic2.api.recipe.Recipes.recyclerWhitelist.isEmpty() || ic2.api.recipe.Recipes.recyclerWhitelist.contains(aInput)?IL.IC2_Scrap.get(1):null;
    }
    
	@Override
	public ItemStack scrapbox(ItemStack aBox) {
		return ic2.api.recipe.Recipes.scrapboxDrops.getDrop(aBox, F);
	}
	
	@Override
	public boolean scrapbox(float aChance, ItemStack aOutput) {
		if (UT.Stacks.invalid(aOutput) || aChance <= 0) return F;
		aOutput = OM.get_(aOutput);
		aOutput.stackSize = 1;
		//if (Config.troll && !UT.Stacks.equal(aOutput, UT.Stacks.make(Items.wooden_hoe, 1, 0))) return F;
		aChance = (float)ConfigsGT.RECIPES.get(ConfigCategories.Machines.scrapboxdrops, aOutput, aChance);
		if (aChance <= 0) return F;
		ic2.api.recipe.Recipes.scrapboxDrops.addDrop(UT.Stacks.copy(aOutput), aChance);
		return T;
	}
	
	private ItemStackSet<ItemStackContainer> mToBlacklist = new ItemStackSet<ItemStackContainer>();
	
	@Override
	public boolean blacklist(ItemStack aBlacklisted) {
		if (UT.Stacks.invalid(aBlacklisted)) return F;
		if (ic2.api.recipe.Recipes.recyclerBlacklist == null) mToBlacklist.add(aBlacklisted); else ic2.api.recipe.Recipes.recyclerBlacklist.add(new RecipeInputItemStack(aBlacklisted));
		return T;
	}
}